
//Direkte LCD Befehle
void writebyte (unsigned char wert);				//Daten an LCD senden
void writecom (unsigned char wert);					//Befehl an LCD senden
void setpwm (unsigned char wert);
void setscroll (unsigned char wert);				//X Start Pos
void setcursor (unsigned int x, unsigned int y);	//Cursorposition(x,y) setzen
void writechar (char text);							//Buchstabe darstellen
void writetext (char *text);						//Text senden
void setpixel (int x, int y);						//Pixel(x,y) setzen
void loadbmp(char *file, unsigned int xp, unsigned int yp,unsigned char invert);	//BMP laden

void getbmp(char *filename);						//Display RAM in BMP schreiben

void transfer (int xmin, int ymin, int xmax, int ymax);	//Puffer bertragen

//LCD Befehle ber Puffer
void lcd_set_pixel (int x, int y);					//Pixel(x,y) setzen
void lcd_line (int x1, int y1, int x2, int y2);		//Linie (x1, y1, x2, y2) zeichnen
void clearbuffer (void);							//Puffer lschen
void lcd_line3d (int x1,int y1,int z1, int x2,int y2,int z2, double W1, double W2, double W3);	//3D Linie mit x1, y1, z1, x2, y2, z2 unter dem Betrachtungswinkel W1, W2, W3 zeichnen

//Intern genutzte Routinen
void bresenham_line (int x1, int y1, int x2, int y2);
void h_line (int x1, int x2, int y);
void v_line (int x, int y1, int y2);

extern unsigned char lcdbuffer[480][1000];

#define color	1		//Mglichkeit zur Invertierung des LCDs

#define XMAX	1000
#define Escape	14

#define PI		3.14159

extern UART LCD;